# coding: utf-8

"""
    Bleumi Pay API

    A simple and powerful REST API to integrate ERC20 payments into your business or application  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: info@bleumi.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six
from bleumi_pay.models.eth_address import EthAddress  # noqa: F401,E501


class WalletCreateInput(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'buyer_address': 'EthAddress',
        'transfer_address': 'EthAddress'
    }

    attribute_map = {
        'id': 'id',
        'buyer_address': 'buyerAddress',
        'transfer_address': 'transferAddress'
    }

    def __init__(self, id=None, buyer_address=None, transfer_address=None):  # noqa: E501
        """WalletCreateInput - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._buyer_address = None
        self._transfer_address = None
        self.discriminator = None
        if id is not None:
            self.id = id
        if buyer_address is not None:
            self.buyer_address = buyer_address
        if transfer_address is not None:    
            self.transfer_address = transfer_address

    @property
    def id(self):
        """Gets the id of this WalletCreateInput.  # noqa: E501

        Unique ID identifying the wallet; specified here to create the wallet by your system  # noqa: E501

        :return: The id of this WalletCreateInput.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this WalletCreateInput.

        Unique ID identifying the wallet; specified here to create the wallet by your system  # noqa: E501

        :param id: The id of this WalletCreateInput.  # noqa: E501
        :type: str
        """
        if id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def buyer_address(self):
        """Gets the buyer_address of this WalletCreateInput.  # noqa: E501


        :return: The buyer_address of this WalletCreateInput.  # noqa: E501
        :rtype: EthAddress
        """
        return self._buyer_address

    @buyer_address.setter
    def buyer_address(self, buyer_address):
        """Sets the buyer_address of this WalletCreateInput.


        :param buyer_address: The buyer_address of this WalletCreateInput.  # noqa: E501
        :type: EthAddress
        """
        if buyer_address is None:
            raise ValueError("Invalid value for `buyer_address`, must not be `None`")  # noqa: E501

        self._buyer_address = buyer_address

    @property
    def transfer_address(self):
        """Gets the transfer_address of this WalletCreateInput.  # noqa: E501


        :return: The transfer_address of this WalletCreateInput.  # noqa: E501
        :rtype: EthAddress
        """
        return self._transfer_address

    @transfer_address.setter
    def transfer_address(self, transfer_address):
        """Sets the transfer_address of this WalletCreateInput.


        :param transfer_address: The transfer_address of this WalletCreateInput.  # noqa: E501
        :type: EthAddress
        """
        if transfer_address is None:
            raise ValueError("Invalid value for `transfer_address`, must not be `None`")  # noqa: E501

        self._transfer_address = transfer_address

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(WalletCreateInput, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, WalletCreateInput):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
