# coding: utf-8

"""
    Bleumi Pay API

    A simple and powerful REST API to integrate ERC20 payments into your business or application  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: info@bleumi.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six


class WalletInputs(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'buyer': 'str',
        'merchant': 'str',
        'wallet_library': 'str',
        'wallet_proxy': 'str',
        'salt': 'str'
    }

    attribute_map = {
        'buyer': 'buyer',
        'merchant': 'merchant',
        'wallet_library': 'walletLibrary',
        'wallet_proxy': 'walletProxy',
        'salt': 'salt'
    }

    def __init__(self, buyer=None, merchant=None, wallet_library=None, wallet_proxy=None, salt=None):  # noqa: E501
        """WalletInputs - a model defined in Swagger"""  # noqa: E501
        self._buyer = None
        self._merchant = None
        self._wallet_library = None
        self._wallet_proxy = None
        self._salt = None
        self.discriminator = None
        if buyer is not None:
            self.buyer = buyer
        if merchant is not None:
            self.merchant = merchant
        if wallet_library is not None:
            self.wallet_library = wallet_library
        if wallet_proxy is not None:
            self.wallet_proxy = wallet_proxy
        if salt is not None:
            self.salt = salt

    @property
    def buyer(self):
        """Gets the buyer of this WalletInputs.  # noqa: E501

        Address of the buyer  # noqa: E501

        :return: The buyer of this WalletInputs.  # noqa: E501
        :rtype: str
        """
        return self._buyer

    @buyer.setter
    def buyer(self, buyer):
        """Sets the buyer of this WalletInputs.

        Address of the buyer  # noqa: E501

        :param buyer: The buyer of this WalletInputs.  # noqa: E501
        :type: str
        """
        if buyer is None:
            raise ValueError("Invalid value for `buyer`, must not be `None`")  # noqa: E501

        self._buyer = buyer

    @property
    def merchant(self):
        """Gets the merchant of this WalletInputs.  # noqa: E501

        Address of the merchant  # noqa: E501

        :return: The merchant of this WalletInputs.  # noqa: E501
        :rtype: str
        """
        return self._merchant

    @merchant.setter
    def merchant(self, merchant):
        """Sets the merchant of this WalletInputs.

        Address of the merchant  # noqa: E501

        :param merchant: The merchant of this WalletInputs.  # noqa: E501
        :type: str
        """
        if merchant is None:
            raise ValueError("Invalid value for `merchant`, must not be `None`")  # noqa: E501

        self._merchant = merchant

    @property
    def wallet_library(self):
        """Gets the wallet_library of this WalletInputs.  # noqa: E501

        Wallet Library address  # noqa: E501

        :return: The wallet_library of this WalletInputs.  # noqa: E501
        :rtype: str
        """
        return self._wallet_library

    @wallet_library.setter
    def wallet_library(self, wallet_library):
        """Sets the wallet_library of this WalletInputs.

        Wallet Library address  # noqa: E501

        :param wallet_library: The wallet_library of this WalletInputs.  # noqa: E501
        :type: str
        """
        if wallet_library is None:
            raise ValueError("Invalid value for `wallet_library`, must not be `None`")  # noqa: E501

        self._wallet_library = wallet_library

    @property
    def wallet_proxy(self):
        """Gets the wallet_proxy of this WalletInputs.  # noqa: E501

        Wallet Proxy address  # noqa: E501

        :return: The wallet_proxy of this WalletInputs.  # noqa: E501
        :rtype: str
        """
        return self._wallet_proxy

    @wallet_proxy.setter
    def wallet_proxy(self, wallet_proxy):
        """Sets the wallet_proxy of this WalletInputs.

        Wallet Proxy address  # noqa: E501

        :param wallet_proxy: The wallet_proxy of this WalletInputs.  # noqa: E501
        :type: str
        """
        if wallet_proxy is None:
            raise ValueError("Invalid value for `wallet_proxy`, must not be `None`")  # noqa: E501

        self._wallet_proxy = wallet_proxy

    @property
    def salt(self):
        """Gets the salt of this WalletInputs.  # noqa: E501

        Salt used to create the wallet  # noqa: E501

        :return: The salt of this WalletInputs.  # noqa: E501
        :rtype: str
        """
        return self._salt

    @salt.setter
    def salt(self, salt):
        """Sets the salt of this WalletInputs.

        Salt used to create the wallet  # noqa: E501

        :param salt: The salt of this WalletInputs.  # noqa: E501
        :type: str
        """
        if salt is None:
            raise ValueError("Invalid value for `salt`, must not be `None`")  # noqa: E501

        self._salt = salt

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(WalletInputs, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, WalletInputs):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
